class_name SaveLoad


const save_location = "user://save.json"

var contents_to_save: Dictionary = {

}


func save() -> void:
	var file: FileAccess = FileAccess.open(save_location, FileAccess.WRITE)
	file.store_var(contents_to_save.duplicate(true))
	file.close()
	print('Saved game at: %s' % file.get_path_absolute())


func load() -> void:
	if FileAccess.file_exists(save_location):
		var file: FileAccess = FileAccess.open(save_location, FileAccess.READ)
		var data: Dictionary = file.get_var()
		file.close()
		
		contents_to_save = data.duplicate(true)
	else:
		contents_to_save.get_or_add('coins', 0)
		contents_to_save.get_or_add('dragons', [])
		contents_to_save.get_or_add('items', [])


func get_coins() -> int:
	return contents_to_save['coins']


func set_coins(coins: int) -> void:
	contents_to_save['coins'] = coins


func clear_dragons() -> void:
	contents_to_save['dragons'] = []


func add_dragon(name: String, hat: int, shirt: int, shoes: int) -> void:
	contents_to_save['dragons'].push_back({'name': name, 'hat': hat, 'shirt': shirt, 'shoes': shoes})


func get_dragons() -> Array:
	return contents_to_save['dragons']


func add_item(id: int, position: Vector2i) -> void:
	contents_to_save['items'].push_back({'id': id, 'position': position})


func get_items() -> Array:
	return contents_to_save['items']
